'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = SyntaxHighlighter;

var _lowlight = require('lowlight');

var _lowlight2 = _interopRequireDefault(_lowlight);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Text = function Text(_ref) {
	var children = _ref.children;
	return _react2.default.createElement(
		'span',
		null,
		children
	);
};

var createStyleObject = function createStyleObject(classNames, style) {
	return classNames.reduce(function (styleObject, className) {
		return _extends({}, styleObject, style[className]);
	}, {});
};

function createChildren(style) {
	var childrenCount = 0;
	return function (children) {
		childrenCount += 1;
		return children.map(function (child, i) {
			return createElement(child, style, 'code-segment-' + childrenCount + '-' + i);
		});
	};
}
function createElement(node, style, key) {
	var properties = node.properties;
	var type = node.type;
	var tagName = node.tagName;
	var value = node.value;

	if (type === "text") {
		return _react2.default.createElement(
			Text,
			{ key: key },
			value
		);
	} else if (tagName) {
		var TagName = tagName;
		var childrenCreator = createChildren(style);
		var nodeStyle = createStyleObject(properties.className, style);
		var children = childrenCreator(node.children);
		return _react2.default.createElement(
			TagName,
			{ key: key, style: nodeStyle },
			children
		);
	}
}

function SyntaxHighlighter(props) {
	var language = props.language;
	var children = props.children;
	var _props$style = props.style;
	var style = _props$style === undefined ? _styles.defaultStyle : _props$style;

	var codeTree = _lowlight2.default.highlight(language, children);
	var defaultPreStyle = style.hljs || { backgroundColor: '#fff' };
	return _react2.default.createElement(
		'pre',
		_extends({}, props, { style: defaultPreStyle }),
		_react2.default.createElement(
			'code',
			null,
			codeTree.value.map(function (node, i) {
				return createElement(node, style, 'code-segement' + i);
			})
		)
	);
}